var $j = jQuery.noConflict();

var TPU = {
  /**
   * Загрузка формы для заполнения
   * @param callback - функция обратного вызова
   * @param _ajax_handle - URL для загрузки файла на сервер
   */
  getForm: function(callback, _ajax_handle) {
	  $j.post(
	      _ajax_handle, 
	      { 'param': 'getform' }, 
	      function(data) {
	    	  if (callback)
	    		  callback('success', data);
	  }, 
	  'json')
	  .error(function() {
    	  if (callback)
    		  callback('error', 'Ошибка');
	  })
	  .complete(function() {
		  
	  });
  },

  /**
   * Функция заливки данных на сервер
   * @param imageData - сама картинка
   * @param callback - функция обратного вызова
   * @param _ajax_handle - URL для загрузки файла на сервер 
   */
  upload: function (imageData, callback, callback_upload, _ajax_handle) {
	  
	  var binaryData = {
		      boundary: MULTIPART_FORMDATA_BOUNDARY,
		      data: imageData,
		      name: 'Filedata',
		      value: 'Google_Chrome_Screen_Capture.png',
		      type: 'image/png'
	      };
	  
      $j("#tpu_form").validate({
	    focusInvalid: false
	  });
	  
      if ( ! $j("#tpu_form").valid() ) {
		return false;
	  } // if
      
      if (callback)
		callback('begin', {});
		
      
      var $items = $j("#tpu_form").find('input, textarea, select');
      var params = new Array();
      
      $items.each(function(ind, el) {
    	  var $obj = $j(el);    	  
    	  var n = $obj.attr('name');
    	  var v = ajax.encodeForBinary($obj.val());
    	  params[n] = v;
      });
            
      ajax({
	        url: _ajax_handle,
	        multipartData: binaryData,
	        parameters: params,
	        progress: function(loaded, total) {
                var percentComplete = Math.ceil(loaded / total * 100);
	            var percentVal = percentComplete + '%';
	            if (callback_upload)
	            	callback_upload(percentVal);
	        },
	        success: function(data) {
	        	if (callback)
	        		callback('success', data);
	        },	        
	        status: {
	            others: function(data) {
	              var message;
	              if (data) {
	            	  message = 'service_unavailable';
	              } else {
	                  message = 'failed_to_connect_to_server';
	              }
	              callback('failure', message);
	            }
	        }
      });
  }
  
};