﻿// PRELOAD
	var b = chrome.extension.getBackgroundPage();

// USER SETTINGS
	var SORTING = false;
	var SORTINGGROUPS = false;
	var COLS = localStorage.getItem('options.columns');
	var GROUPS = new Array();
  var GROUP = 0;

  if(window.location.hash) {
    GROUP = window.location.hash.replace('#','');
  }
			
// SPEED DIAL
	var speeddial = {};
	speeddial.storage = {};
	speeddial.storage.db = null;

// FUNCTIONS
	speeddial.storage.open = function() {
	  var dbSize = 1 * 1024 * 1024; // 2MB
	  speeddial.storage.db = null;
	  speeddial.storage.db = openDatabase('bookmarks', '1.0', 'Speeddial2', dbSize);
	}
// DEFAULT ERROR TX FUNCTION
	speeddial.storage.onError = function(tx, e) {
	  alert('Something unexpected happened: ' + e.message );
	}
// DEFAULT SUCCESS TX FUNCTION	
	speeddial.storage.onSuccess = function(tx, r) {
	  speeddial.storage.getAllItems(loadItems);
	}

// CREATE/ALTER/DROP TABLE

// --------- BOOKMARKS

	speeddial.storage.createTable = function(callback) {
	  speeddial.storage.db.transaction(function(tx) {
	    tx.executeSql('CREATE TABLE IF NOT EXISTS ' + 
	      'bookmarks(id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, title TEXT, url TEXT, thumbnail TEXT NULL, ts_created INTEGER, visits INTEGER, visits_morning INTEGER, visits_afternoon INTEGER, visits_evening INTEGER, visits_night INTEGER, position INTEGER, idgroup INTEGER)', [],
	      callback,speeddial.storage.onError);
	  });
	}
	speeddial.storage.convertTable = function() {
	  speeddial.storage.db.transaction(function(tx) {
	    tx.executeSql('ALTER TABLE bookmarks ADD COLUMN idgroup INTEGER DEFAULT 0',[],null,null);
	  });
	}
	speeddial.storage.dropTableBookmarks = function(callback) {
	  speeddial.storage.db.transaction(function(tx) {
	    tx.executeSql('DROP TABLE bookmarks',[],callback,speeddial.storage.onError);
	  });
	}
	speeddial.storage.getAllItems = function(renderFunc, allgroups) {
	  speeddial.storage.db.transaction(function(tx) {
			// default order
			var query = 'SELECT * FROM bookmarks WHERE idgroup = ? ORDER BY visits DESC';
			// user selected order
	  	if (localStorage.getItem('options.order')=='position') 
			{ query = 'SELECT * FROM bookmarks WHERE idgroup = ? ORDER BY position ASC, ts_created ASC'; }
			
			if (allgroups==true) {
			query = 'SELECT * FROM bookmarks ORDER BY position ASC';
			tx.executeSql(query, [], renderFunc, speeddial.storage.onError);  
		  } else {
		  tx.executeSql(query, [GROUP], renderFunc, speeddial.storage.onError);  
		  } 
	  });
	}	
	speeddial.storage.getItem = function(id,renderFunc) {
	  speeddial.storage.db.transaction(function(tx) {
	    tx.executeSql('SELECT * FROM bookmarks WHERE id = ?', [id], renderFunc, 
	      speeddial.storage.onError);
	  });
	}	
	speeddial.storage.addItem = function(bookmark, callback) {
		if (!callback) {callback = speeddial.storage.onSuccess }
		
		if (typeof bookmark['idgroup']=="undefined") bookmark['idgroup'] = 0;
				
    speeddial.storage.db.transaction(function(tx){
	    tx.executeSql('INSERT INTO bookmarks (title, url, thumbnail, ts_created, visits, visits_morning, visits_afternoon, visits_evening, visits_night, position, idgroup) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', 
	      [bookmark['title'], bookmark['url'], bookmark['thumbnail'], bookmark['ts_created'], bookmark['visits'], bookmark['visits_morning'], bookmark['visits_afternoon'], bookmark['visits_evening'], bookmark['visits_night'], bookmark['position'],bookmark['idgroup']],
	      callback,speeddial.storage.onError);
	  });	
	}	
	speeddial.storage.editItem = function(bookmark,clearVisitsData) {

		if (!bookmark) return false;
		if (clearVisitsData == true) { clearData = ',visits=0';  } else { clearData = ''; }
	  speeddial.storage.db.transaction(function(tx){
	    tx.executeSql('UPDATE bookmarks SET title=?, url=?, thumbnail =?, idgroup =? '+clearData+' WHERE id=?', 
	      [bookmark['title'], bookmark['url'], bookmark['thumbnail'], bookmark['idgroup'], bookmark['id']],
	      speeddial.storage.onSuccess,speeddial.storage.onError);
	  });
	};
	speeddial.storage.deleteItem = function(id) {
	  speeddial.storage.db.transaction(function(tx) {
	    tx.executeSql('DELETE FROM bookmarks WHERE ID=?', [id],
	      null, speeddial.storage.onError);
	  });
	}
	speeddial.storage.updateItemOrder = function(id,position) {
	  speeddial.storage.db.transaction(function(tx) {
	    tx.executeSql('UPDATE bookmarks SET position=? WHERE ID=?', [position,id],
	      null, speeddial.storage.onError);
	  });
	}

// --------- END : BOOKMARKS
	
// --------- GROUPS 

	speeddial.storage.createGroupsPositions = function() {
	  speeddial.storage.db.transaction(function(tx) {
	    tx.executeSql('ALTER TABLE groups ADD COLUMN position INTEGER DEFAULT 0',[],null,null);
	  });
	}
	speeddial.storage.createGroups = function(callback) {
	  speeddial.storage.db.transaction(function(tx) {
	    tx.executeSql('CREATE TABLE IF NOT EXISTS ' + 'groups(id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, title TEXT, color TEXT, position INTEGER DEFAULT 0)', [], callback,speeddial.storage.onError);
	  });
	}
	speeddial.storage.dropTableGroups = function(callback) {
	  speeddial.storage.db.transaction(function(tx) {
	    tx.executeSql('DROP TABLE groups',[],callback,speeddial.storage.onError);
	  });
	}
	speeddial.storage.getGroups = function(callback) {
	  speeddial.storage.db.transaction(function(tx) {

      GROUPS = [];
      GROUPS.length = 0;
			// default order
			var query = 'SELECT * FROM groups ORDER BY position ASC, title ASC';
			// user selected order
 	    tx.executeSql(query, [], callback, speeddial.storage.onError);
	  });
	}	
	speeddial.storage.getGroup = function(id,renderFunc) {
	  speeddial.storage.db.transaction(function(tx) {
	    tx.executeSql('SELECT * FROM groups WHERE id = ?', [id], renderFunc, speeddial.storage.onError);
	  });
	}	
	speeddial.storage.addGroup = function(group, callback) {
		if (!callback) {callback = speeddial.storage.onSuccess }
	  if (group['id']) {
		  speeddial.storage.db.transaction(function(tx){
	      tx.executeSql('INSERT INTO groups (id, title, color, position) values (?, ?, ?, ?)', [group['id'], group['title'], group['color'], group['position']],callback,speeddial.storage.onError);
	    });
	  } else {
		  speeddial.storage.db.transaction(function(tx){
	      tx.executeSql('INSERT INTO groups (title, color) values (?, ?)', [group['title'], group['color']],callback,speeddial.storage.onError);
	    });
	  }
	}	
	speeddial.storage.editGroup = function(group) {
		if (!group) return false;
	  speeddial.storage.db.transaction(function(tx){
	    tx.executeSql('UPDATE groups SET title=?, color =? WHERE id=?', 
	      [group['title'], group['color'], group['id']],
	      reload(),speeddial.storage.onError);
	  });
	};
	speeddial.storage.setGroupPosition = function(group, position) {
		if (!group || !position) return false;
	  speeddial.storage.db.transaction(function(tx){
	    tx.executeSql('UPDATE groups SET position=? WHERE id=?', 
	      [position, group],
	      null,speeddial.storage.onError);
	  });
	};	
	
	speeddial.storage.moveToGroup = function(idDial,idGroup,callback) {
	  if (parseInt(idDial)>0 && parseInt(idGroup)>=0) {
	  speeddial.storage.db.transaction(function(tx){
	    tx.executeSql('UPDATE bookmarks SET idgroup=?,position=? WHERE id =?', 
	      [idGroup,999,idDial],callback,speeddial.storage.onError);
	  });
    }
	};
	speeddial.storage.deleteGroup = function(id) {
	  if (parseInt(id)>0) {
	  speeddial.storage.db.transaction(function(tx) {
	    tx.executeSql('DELETE FROM groups WHERE ID=?', [id],
	      function(){
	        query = 'SELECT * FROM bookmarks WHERE idgroup = ? ORDER BY position ASC';
 	        tx.executeSql(query, [id], function(tx,rs){
	          for (var i=0; i < rs.rows.length; i++) {
              row = rs.rows.item(i);
              
              speeddial.storage.removeThumbnail(row.url);
              //localStorage.removeItem('thumbnail_' + encodeURIComponent(row.url));
              
	            speeddial.storage.db.transaction(function(tx){
	              tx.executeSql('DELETE FROM bookmarks WHERE id =?', [row.id],null,null);
	            });
	          }
	          reload();
 	        }, speeddial.storage.onError);
	      }, speeddial.storage.onError);
	  });
    }
	}

// --------- END : GROUPS

// --------- THUMBNAILS

	speeddial.storage.createTableThumbnails = function(callback) {
  	  speeddial.storage.db.transaction(function(tx) {
  	    tx.executeSql('CREATE TABLE IF NOT EXISTS ' + 'thumbnails(url TEXT NOT NULL, thumbnail TEXT)', [], function() { speeddial.storage.convertToTableThumbnails() } ,speeddial.storage.onError);
  	  });
	}
	speeddial.storage.insertThumbnail = function(url, thumbnail, callback) {
	  console.log('Inserting thumbnail - '+url);
    speeddial.storage.db.transaction(function(tx) {
      tx.executeSql('DELETE FROM thumbnails WHERE url = ?', [url],function(){
        tx.executeSql('INSERT INTO thumbnails (url, thumbnail) values (?, ?)', [url, thumbnail],function(){
          speeddial.storage.removeCacheThumbnail(url)  
        },speeddial.storage.onError);  
      },speeddial.storage.onError);
    });
  }
  speeddial.storage.removeThumbnail = function(url) {
    speeddial.storage.db.transaction(function(tx) {
      tx.executeSql('DELETE FROM thumbnails WHERE url = ?', [url], null, speeddial.storage.onError);
    });
  }
	speeddial.storage.getThumbnail = function(url, element, parent) {
    speeddial.storage.db.transaction(function(tx) {
      tx.executeSql('SELECT * FROM thumbnails WHERE url = ? LIMIT 1', [url], function(tx,rs){
      
        if (rs.rows.length > 0) {
          element.style.backgroundImage = 'url('+rs.rows.item(0).thumbnail+')';  
          parent.setAttribute("class", "link"); 
        } else {
          parent.setAttribute("class", "link no-thumbnail");
        }
        
      },speeddial.storage.onError);
    });
  }
  speeddial.storage.ThumbnailRemoveIfDoesntExists = function(url) {
    speeddial.storage.db.transaction(function(tx) {
    tx.executeSql('SELECT * FROM bookmarks WHERE url = ?', [url], function(tx,rs){
      if (rs.rows.length <= 0) {
        tx.executeSql('DELETE FROM thumbnails WHERE url = ?', [url], null, speeddial.storage.onError);
        console.log('Removed url - '+url);
      }
    },speeddial.storage.onError)})
    
  }
  speeddial.storage.optimizeThumbnailCache = function() {
    speeddial.storage.db.transaction(function(tx) {
      tx.executeSql('SELECT * FROM thumbnails', [], function(tx,rs){
        // for each thumbnail: check if thumb. url exist - then KEEP of REMOVE
        console.log('optimizeThumbnailCache - Selected all bookmarks');
	      for (var i=0; i < rs.rows.length; i++) {
	        console.log('optimizeThumbnailCache - check '+rs.rows.item(i).url);
	        speeddial.storage.ThumbnailRemoveIfDoesntExists( rs.rows.item(i).url );
        }
      },speeddial.storage.onError);
    });
  }
  speeddial.storage.removeCacheThumbnail = function(url) {
      // rather not going to use this
		  //localStorage.removeItem('thumbnail_'   + encodeURIComponent(url));
		  //console.log('removed cache thumbnail - '+url);
		  return true;
  }
	speeddial.storage.convertToTableThumbnails = function(callback) {
    if (!localStorage.getItem('thumbnails_been_converted')) {
	  for (var i=0; i < window.localStorage.length; i++) {
	  	key = localStorage.key(i);
	  	if (key.indexOf('thumbnail_')==0) {
	  		speeddial.storage.insertThumbnail(decodeURIComponent(localStorage.key(i).replace("thumbnail_", "")), localStorage.getItem(localStorage.key(i)), null);
  	  }
	  };
	  localStorage.setItem('thumbnails_been_converted','1');
    }
	}

// --------- END : THUMBNAILS

// --------- MISCELLANEOUS

	speeddial.storage.alterTable = function(query) {
	  speeddial.storage.db.transaction(function(tx){
	    tx.executeSql(query, [],null, speeddial.storage.onError);
	  });
	}	
	speeddial.storage.hightlightExperimental = function() {
		if (localStorage['options.highlight']==1) {
			var dayPart = '';
			var hours = new Date().getHours();
			if ( hours >= 0  ) dayPart = 'night';
			if ( hours >= 6  ) dayPart = 'morning';
			if ( hours >= 12 ) dayPart = 'afternoon';
			if ( hours >= 18 ) dayPart = 'evening';
			var query = 'SELECT id FROM bookmarks WHERE idgroup='+GROUP+' ORDER BY visits_'+dayPart+' DESC LIMIT 3';
		  speeddial.storage.db.transaction(function(tx) {
				tx.executeSql(query, [], function(tx, rs){
				  console.log(GROUP + ' ' +rs.rows.length);
		  		for (var i=0; i < rs.rows.length; i++) {
		  			//$('#pages li#'+rs.rows.item(i).id).addClass('highlighted');
		  			$('#pages li#'+rs.rows.item(i).id).find('.thumbnail_container').prepend('<img src="images/highlighted.png" class="highlight_corner" />');
		  		}
		  		PADDING = parseInt(localStorage['options.padding'])
		  		$('.highlight_corner').css({top:-PADDING,right:-PADDING})
				},null,speeddial.storage.onError);
		  });
		}
	}	
	speeddial.storage.trackVisits = function(url) {

		// keep track of part of a day
		var dayPart = '';
		var hours = new Date().getHours();

		if ( hours >= 0  ) dayPart = 'night';
		if ( hours >= 6  ) dayPart = 'morning';
		if ( hours >= 12 ) dayPart = 'afternoon';
		if ( hours >= 18 ) dayPart = 'evening';
	  
	  speeddial.storage.db.transaction(function(tx) {
	    tx.executeSql('UPDATE bookmarks SET visits=visits+1, visits_'+dayPart+'=visits_'+dayPart+'+1 WHERE url=?', [url],
	      null, speeddial.storage.onError);
	  });
	}
	function chceckContextMenuAddRequest() {

    console.log(localStorage['addPageFromContextMenu']);
	  if (typeof localStorage['addPageFromContextMenu']!="undefined" && localStorage['addPageFromContextMenu']!="null" && localStorage['addPageFromContextMenu']!="undefined" && localStorage['addPageFromContextMenu']) {
	    
	    var pagesToAdd = localStorage['addPageFromContextMenu'].split('|page|');
	    for (var i=0; i < pagesToAdd.length; i++) {
	      
	      var thisPage = pagesToAdd[i].split('|||');

        if (thisPage!='' && thisPage!='undefined') {

		      insert = new Array();

		      insert['title'] 					= thisPage[1];
		      insert['url'] 						= thisPage[0];
		      insert['idgroup'] 				= thisPage[2];
		      insert['thumbnail'] 			= '';
		      insert['ts_created'] 			= Math.round(new Date().getTime() / 1000);
		      insert['visits'] 					= 0;
		      insert['visits_morning'] 	= 0;
		      insert['visits_afternoon']= 0;
		      insert['visits_evening'] 	= 0;
		      insert['visits_night'] 		= 0;
		      insert['position'] 				= 999;
		    
		      speeddial.storage.addItem(insert, null);
	      }
	    };
	    localStorage['addPageFromContextMenu'] = '';
	  }
	}

// --------- END : MISCELLANEOUS

// --------- RENDER FUNCTIONS

  speeddial.storage.showGroups = function(tx,rs) {

	  for (var i=0; i < rs.rows.length; i++) {
	    GROUPS.push(rs.rows.item(i));
    }

    // url-dialog selectbox
		var cat = document.getElementById('url-dialog-groups');
		var grouplist = document.getElementById('groups');
		
		if (grouplist) {
		  cat.innerHTML = '<option value="0">По умолчанию</option><option value="">------</option><option value="-1" style="color:#369B43">Создать новую группу</option><option value="">------</option>';
		  grouplist.innerHTML = '';
		}

    if (GROUPS.length==0) return false;

    // HOME group

      var li   = document.createElement("li");
      var link = document.createElement("a");

      link.setAttribute('class','group');
      li.setAttribute('loadgroup',0);
      link.setAttribute('href','#');
      li.setAttribute('class','home');
      
      link.style.borderColor = '#fff';
      link.style.backgroundColor = '#fff';
      link.innerHTML = localStorage['options.defaultGroupName'];
      if ( GROUP == 0) { link.setAttribute('class','group selected'); }

      li.appendChild(link)
      grouplist.appendChild(li)

      for (var i=0; i < GROUPS.length; i++) {
  
        // #groups
        var li   = document.createElement("li");
        var link = document.createElement("a");
        
        link.setAttribute('class','group');
        link.setAttribute('href','#'+GROUPS[i].id);
        li.setAttribute('color',GROUPS[i].color);
        li.setAttribute('loadgroup',GROUPS[i].id);
        // selected 
        if ( GROUPS[i].id == GROUP ) { link.setAttribute('class','group selected'); }
        
        link.style.borderColor = '#'+GROUPS[i].color;
        link.style.backgroundColor = '#'+GROUPS[i].color;
        link.innerHTML = GROUPS[i].title
        
        li.appendChild(link)
        grouplist.appendChild(li)
  
        // #url-dialog selectbox
  	    var option = document.createElement('option');
  	    option.setAttribute('value',GROUPS[i]['id']);
  	    option.innerHTML = GROUPS[i]['title'];
  	    cat.appendChild(option);
  
      };		
      cat.value = GROUP;
  }

	function loadItems(tx, rs) {

    // prepare elements
	  var row, position;
	  var container = document.getElementById('pages');
        container.innerHTML = ''; 
	  var groupscontainer = document.getElementById('groups');
	  
    var browser_toolbar = 130;
    
    var groups_space = 90;
    // experimental
    if (GROUPS.length > 0) groups_space = 30 + parseInt ( $('#groups').css('height') );
    
    var apps_space = [];
        apps_space['large'] = 124;
        apps_space['medium'] = 102;
        apps_space['small'] = 86;
        apps_space['extrasmall'] = 66;

        // title height      
    var TITLE = 24,
        // number of rows
        ROWS = Math.ceil(rs.rows.length/COLS)
        // custom spacing
        SPACING = parseInt(localStorage['options.dialspacing'])
        // LOAD GROUPS
        NUMBER_OF_GROUPS = GROUPS.length
        // custom padding
        PADDING = parseInt(localStorage['options.padding'])
        // custom zoom ?
	      WIDTHMODIFIER = ( parseInt(getValue('options.dialSpace'))>0 ) ? ( getValue('options.dialSpace') / 100 ) : 0.9
        // screen dimensions
  		  WINDOW_WIDTH  = window.screen.width
	  	  WINDOW_HEIGHT = window.screen.height
  		  WINDOW_INNER_WIDTH  = window.innerWidth
	  	  // avail space
	  	  SPACE = window.innerHeight
        // thumbnail ration (screen capture taken by Chrome should have this ratio)
	  	  RATIO = (( WINDOW_HEIGHT - browser_toolbar ) / WINDOW_WIDTH )
        // 
	  	  RATIO_MODIFIED = false;
  	    
	  var CONTAINER_TOP = 15;
  	    
	  	  if (NUMBER_OF_GROUPS==0 && localStorage['options.centerVertically']=='1') {
	  	    CONTAINER_TOP = 0;  
	  	  } 
	  	  
        

		// maximized Chrome inner window ratio
    if (RATIO < 0.55) { RATIO = 0.55; RATIO_MODIFIED = true }
		if (RATIO > 0.65) { RATIO = 0.65; }

    // space taken by Groups and Apps panels !
    if (localStorage['options.apps.show']=='1') 
    { 
        SPACE -= apps_space[localStorage['options.apps.iconsize']]; 
        if (localStorage['options.apps.position']=='top') {
          
          if (NUMBER_OF_GROUPS>0) $('#groups').css('top',apps_space[localStorage['options.apps.iconsize']]);    
          //$('#pages').css('top',10 + apps_space[localStorage['options.apps.iconsize']]);
          container.style.top = 15 + apps_space[localStorage['options.apps.iconsize']];
          CONTAINER_TOP += apps_space[localStorage['options.apps.iconsize']];
          
        }
    } 
    if (NUMBER_OF_GROUPS>0) 
        { SPACE -= groups_space; } 
        
		var DIALSPACE = WIDTHMODIFIER * WINDOW_INNER_WIDTH;
		var DIALWIDTH = ( DIALSPACE - ( (COLS) * SPACING ) )  / COLS ;
    		if (DIALWIDTH>360) DIALWIDTH = 360;

    var DIALHEIGHT = ( DIALWIDTH * RATIO );

    // show title?
    if (localStorage['options.showTitle']!=1) { 
      TITLE = PADDING + 2;
    }

    var RESIZEDDIALS = false;
    
    if ( ( ROWS * (DIALHEIGHT+SPACING+PADDING+TITLE) ) > SPACE  ) {
      
      RESIZEDDIALS = true;
      DIALHEIGHT = ( SPACE - ( ROWS * ( SPACING+PADDING+TITLE ) ) ) / ROWS;
      DIALWIDTH = DIALHEIGHT / RATIO; 
      
    }

    
    if (localStorage['options.centerVertically']=='1' && RESIZEDDIALS == false) {
      
      if (NUMBER_OF_GROUPS == 0) {
        //CONTAINER_TOP -= groups_space;  
        CONTAINER_TOP -= 15;  
      } else {
        
      }
      
    }

    // PAGES
    container.style.width =  COLS*(DIALWIDTH+SPACING)+'px';

    var THUMBNAILHEIGHT = ( ( DIALWIDTH - (2 * PADDING) ) * RATIO ) + PADDING ;

    // GROUPS
    //var gWidth =  ( window.innerWidth - ( COLS*(DIALWIDTH+SPACING) ) ) / 2  ;
    if (NUMBER_OF_GROUPS>0) {
      var gWidth =  ( WIDTHMODIFIER * window.innerWidth );
      groupscontainer.style.paddingLeft =  SPACING/2 + (window.innerWidth - gWidth) / 2; 
      groupscontainer.style.paddingRight =  SPACING/2 + (window.innerWidth - gWidth) / 2; 
      groupscontainer.style.display = 'block';
    }
    
    // --RENDER EACH--

	  for (var i=0; i < rs.rows.length; i++) {

        row = rs.rows.item(i);
        position=i+1;
        
        CURRENT_ROW = Math.ceil(position/COLS);
        CURRENT_COL = ((position-1)%COLS)+1;
  
        var li
          = document.createElement("li");
        var link
          = document.createElement("a");
        var thumbnail_container 
          = document.createElement("div");
        var dialtitle
          = document.createElement("div");
        var shadow
          = document.createElement("div");

        li.setAttribute("class", "link"); 
        li.setAttribute("id", row['id']); 
        li.setAttribute("url", row['url']); 
        li.setAttribute("position", position); 
        li.setAttribute("visits", row['visits']); 
        li.setAttribute("row", CURRENT_ROW); 
        li.setAttribute("col", CURRENT_COL); 
        li.setAttribute("visits", row['visits']); 
        link.setAttribute('href',row['url']);
        link.style.width = DIALWIDTH+'px';
        dialtitle.style.width = DIALWIDTH-2*PADDING;
        dialtitle.style.marginLeft = SPACING/2+'px';
        dialtitle.style.display = 'block'
        dialtitle.style.margin = '0 auto'
        dialtitle.setAttribute('class','title');
        dialtitle.innerHTML = row['title'] 
        
        
        
        // DO WE RENDER IMAGE (THUMBNAIL OR CUSTOM THUMBNAIL)
        if (row['thumbnail']!='') {

            li.setAttribute("custom_thumbnail", "true"); 

            // 100% height and center vertically
            if (localStorage['options.centerThumbnailsVertically']=='2') 
            {
              thumbnail_container.style.backgroundSize = '100%'; 
              thumbnail_container.style.backgroundPosition = 'center center';
            }
            // fit to thumbnails container
            else if (localStorage['options.centerThumbnailsVertically']=='1') 
            {
              thumbnail_container.style.backgroundSize = 'contain'; 
              thumbnail_container.style.backgroundPosition = 'center center';
            }
            // fit to thumbnails container
            else if (localStorage['options.centerThumbnailsVertically']=='0') 
            {
              thumbnail_container.style.backgroundSize = '100%'; 
              thumbnail_container.style.backgroundPosition = 'top center';
            }
            else {
              thumbnail_container.style.backgroundSize = 'auto'; 
              thumbnail_container.style.backgroundPosition = 'top center';
            }
            thumbnail_container.style.backgroundImage = 'url('+row['thumbnail']+')';

        } else {
          
              if (RATIO_MODIFIED == true) {
                thumbnail_container.style.backgroundSize = '102% 100%'; // nove
              } else {
                thumbnail_container.style.backgroundSize = '102%'; // nove
              }
              speeddial.storage.getThumbnail(row['url'], thumbnail_container, li);
              
        }

        // widths and heights

        thumbnail_container.setAttribute('class','thumbnail_container');
        thumbnail_container.style.height = THUMBNAILHEIGHT;
        link.appendChild(thumbnail_container)
        link.style.height = THUMBNAILHEIGHT + PADDING + TITLE;
        link.style.padding = PADDING+'px';
        link.style.margin = SPACING/2;
        li.style.height = THUMBNAILHEIGHT + PADDING + TITLE + SPACING;
        li.style.overflow = 'hidden';
        
        // title at the bottom 
        if (localStorage['options.dialstyle.titleposition']!='bottom') {
          
          if (localStorage['options.showTitle']==1) { 
            li.appendChild(dialtitle);
          }
          link.appendChild(thumbnail_container)
          link.style.marginTop = 0;
          link.style.height = THUMBNAILHEIGHT + PADDING + PADDING+2;

        // title at the top
        } else {
          
          link.appendChild(thumbnail_container)
          if (localStorage['options.showTitle']==1) { 
            link.appendChild(dialtitle)
          }
          link.style.paddingBottom = 0;
          thumbnail_container.style.height = THUMBNAILHEIGHT;

        }
        
        if (localStorage['options.showVisits']==1) {
          var visits = document.createElement('span');
          visits.setAttribute('class','visits');
          visits.innerHTML = row['visits']
          dialtitle.appendChild(visits)
        }

        shadow.style.width = DIALWIDTH;
        shadow.style.bottom = SPACING/2 - 10; 
        shadow.style.left = '50%'
        shadow.style.marginLeft =  -DIALWIDTH/2;
        shadow.setAttribute('class','shadow');
        
        if (localStorage['options.dialstyle.titleposition']!='bottom') {
          shadow.style.bottom = 'auto';
          if (localStorage['options.showTitle']==1) {
            shadow.style.top = 25 + DIALHEIGHT + 2*PADDING;  
          } else {
            shadow.style.top = 1 + DIALHEIGHT + 2*PADDING;  
          }
          
        }

        li_x = (CURRENT_COL-1) * DIALWIDTH + ( (CURRENT_COL-1 ) * (SPACING) );
        li_y = (CURRENT_ROW-1) * DIALHEIGHT + ( (CURRENT_ROW-1 ) * ( SPACING + PADDING + TITLE ) );;
        li_y = (CURRENT_ROW-1) * (THUMBNAILHEIGHT + PADDING + TITLE + SPACING);

        li.appendChild(link);
        li.appendChild(shadow);
        li.style.left = li_x; 
        li.style.top = li_y; 
        
				container.appendChild(li);

	  }
	  

    // CENTER VERTICALLY?
		if (localStorage['options.centerVertically']=='1' && RESIZEDDIALS==false) 
		{
      var rowsheight = ( ROWS * (THUMBNAILHEIGHT + 2*PADDING + 2*SPACING) ); 
	    var top = (SPACE-rowsheight)/2;
	    //alert(SPACE+' '+rowsheight);
	    if (top >= 0) {
	      
	      container.style.top = CONTAINER_TOP + ((SPACE-rowsheight)/2);
	      
	    } else {
	      
	      container.style.top = 15;
	      
	    }
		} else {
		    container.style.top = CONTAINER_TOP;
		} 
		
    // SHOW ADD DIAL BUTTON?
    if (getValue('options.showAddButton')==1) {

      position+=1;

      CURRENT_ROW = Math.ceil(position/COLS);
      CURRENT_COL = ((position-1)%COLS);

      li_x = (CURRENT_COL) * DIALWIDTH + ( (CURRENT_COL ) * (SPACING) );
      li_y = (CURRENT_ROW-1) * (THUMBNAILHEIGHT + PADDING + TITLE + SPACING);

      position = rs.rows.length+1;

      emptyrow = document.createElement('li');
      emptyrow.setAttribute('id','emptyrow');
      emptyrow.innerHTML = '<img src="images/plus.png" />';
      emptyrow.style.width = SPACING+DIALWIDTH+'px';
      emptyrow.style.height= SPACING + PADDING +DIALHEIGHT+'px';
      
      emptyrow.addEventListener('click',function(){ switchDialog('add'); });

      emptyrow.style.left = li_x; 
      emptyrow.style.top = li_y; 

      container.appendChild(emptyrow);

    }

    if (NUMBER_OF_GROUPS>0) {} else { $('#groups').hide(); }


    localStorage.setItem('sys.dialwidth',DIALWIDTH);
    localStorage.setItem('sys.dialheight',THUMBNAILHEIGHT + PADDING + TITLE)
    localStorage.setItem('sys.cellspacing',SPACING)
    localStorage.setItem('sys.rowspacing',SPACING)
    localStorage.setItem('sys.rows',ROWS)
    localStorage.setItem('sys.cols',COLS)
    localStorage.setItem('sys.containerwidth',COLS*(DIALWIDTH)+((COLS-1)*SPACING)+'px')
    
    pagesOnLoad();
    speeddial.storage.hightlightExperimental();
    
	}
	

// INIT FUNCTIONS
	
	function init() 
	{
	  speeddial.storage.open();
    // create table bookmarks if not exists
	  speeddial.storage.createTable();
	  // alter bookmarks add column idgroup
	  speeddial.storage.convertTable();
	  // create table groups
	  speeddial.storage.createGroups();
	  speeddial.storage.createGroupsPositions();
	  // create table thumbnails
	  speeddial.storage.createTableThumbnails();
	  // get all groups
	  speeddial.storage.getGroups(speeddial.storage.showGroups);
	  // is there a request to add page from context menu?
	  chceckContextMenuAddRequest();
	  // load all dials
	  speeddial.storage.getAllItems(loadItems);
    // red corners
	  // speeddial.storage.hightlightExperimental();
	}		
	function reload() 
	{
	  speeddial.storage.getGroups(speeddial.storage.showGroups);
	  // is there a request to add page from context menu?
	  chceckContextMenuAddRequest();
	  speeddial.storage.getAllItems(loadItems);
    // red corners
	  // speeddial.storage.hightlightExperimental();
	}
	function background_init() 
	{
	  speeddial.storage.open();
    // create table bookmarks if not exists
	  speeddial.storage.createTable();
	  // alter bookmarks add column idgroup
	  speeddial.storage.convertTable();
	  // create table groups
	  speeddial.storage.createGroups();
	  speeddial.storage.createGroupsPositions();
	  // create table thumbnails
	  speeddial.storage.createTableThumbnails();
	  // get all groups
	}		
	